import React from "react";
declare type GetProps<T> = T extends React.ComponentType<infer P> ? P : any;
declare type ReturnTypeNoConstraints<T> = T extends (...args: any) => infer R ? R : any;
declare type Arguments<T> = T extends (args: infer P) => any ? P : any;
declare type ExtractArray<T> = T extends Array<infer P> ? P : any;
declare type UnionToIntersection<U> = (U extends any ? (k: U) => void : never) extends (k: infer I) => void ? I : never;
declare type GetPropsFromArray<T extends [...any[]]> = {
    [I in keyof T]: GetProps<Arguments<T[I]>>;
};
declare type GetOutcomePropsFromArray<T extends Array<(...args: any) => any>> = {
    [I in keyof T]: GetProps<ReturnTypeNoConstraints<T[I]>>;
};
declare type GetOutcomePropertiesFromArray<T extends Array<(...args: any) => any>> = {
    [I in keyof T]: ReturnTypeNoConstraints<T[I]>;
};
export declare function compose<A extends ((...args: any[]) => any)[]>(...wrappers: A): <P = {}>(WrappedComponent: React.FC<UnionToIntersection<ExtractArray<GetPropsFromArray<A>>> & P>) => React.FC<UnionToIntersection<ExtractArray<GetOutcomePropsFromArray<A>>> & P> & Pick<UnionToIntersection<ExtractArray<GetOutcomePropertiesFromArray<A>>>, Exclude<keyof UnionToIntersection<ExtractArray<GetOutcomePropertiesFromArray<A>>>, keyof UnionToIntersection<ExtractArray<GetOutcomePropsFromArray<A>>>>>;
export {};
