/// <reference types="react" />
import { ExtractArray } from "./types";
export declare class ParamsValidation<T = never> {
    private _rules?;
    param: "params";
    private regexes;
    constructor(_rules?: {
        string: boolean | RegExp | import("react").ReactText[];
        number: boolean | RegExp | import("react").ReactText[];
        enum: boolean | RegExp | import("react").ReactText[];
        regex: boolean | RegExp | import("react").ReactText[];
        optional: boolean | RegExp | import("react").ReactText[];
    } | undefined);
    generateRules: (paramKey: string) => string | undefined;
    enum<A extends Array<number | string>>(...a: A): ParamsValidation<T | ExtractArray<A>>;
    get string(): ParamsValidation<string | T>;
    regex(reg: RegExp): ParamsValidation<string | T>;
    get number(): ParamsValidation<number | T>;
    get optional(): ParamsValidation<T | undefined>;
}
export declare const p: ParamsValidation<never>;
